/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.35 from the
 * contents of Fast.xs. Do not edit this file, edit Fast.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Redis/Fast.xs"
#define PERL_NO_GET_CONTEXT
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"
#include "hiredis.h"
#include "hiredis_ssl.h"
#include "async.h"

#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <poll.h>
#include <sys/socket.h>

#define MAX_ERROR_SIZE 256

#define WAIT_FOR_EVENT_OK 0
#define WAIT_FOR_EVENT_READ_TIMEOUT 1
#define WAIT_FOR_EVENT_WRITE_TIMEOUT 2
#define WAIT_FOR_EVENT_EXCEPTION 3

#define FLAG_INSIDE_TRANSACTION 0x01
#define FLAG_INSIDE_WATCH       0x02

#define DEBUG_MSG(fmt, ...) \
    if (self->debug) {                                                  \
        fprintf(stderr, "[%d][%d][%s:%d:%s]: ", getpid(), getppid(), __FILE__, __LINE__, __func__);  \
        fprintf(stderr, fmt, __VA_ARGS__);                              \
        fprintf(stderr, "\n");                                          \
    }

#define EQUALS_COMMAND(len, cmd, expected) ((len) == sizeof(expected) - 1 && memcmp(cmd, expected, sizeof(expected) - 1) == 0)

typedef struct redis_fast_s {
    redisAsyncContext* ac;
    char* hostname;
    int port;
    char* path;
    char* error;
    double reconnect;
    int every;
    int debug;
    double cnx_timeout;
    double read_timeout;
    double write_timeout;
    int current_database;
    int need_reconnect;
    int is_connected;
    SV* on_connect;
    SV* on_build_sock;
    SV* data;
    SV* reconnect_on_error;
    double next_reconnect_on_error_at;
    int proccess_sub_count;
    int is_subscriber;
    int expected_subs;
    pid_t pid;
    int ssl;
    int ssl_verify_mode;
    int flags;
} redis_fast_t, *Redis__Fast;

typedef struct redis_fast_reply_s {
    SV* result;
    SV* error;
} redis_fast_reply_t;

typedef redis_fast_reply_t (*CUSTOM_DECODE)(pTHX_ Redis__Fast self, redisReply* reply, int collect_errors);

typedef struct redis_fast_sync_cb_s {
    redis_fast_reply_t ret;
    int collect_errors;
    CUSTOM_DECODE custom_decode;
    int on_flags;
    int off_flags;
} redis_fast_sync_cb_t;

typedef struct redis_fast_async_cb_s {
    SV* cb;
    int collect_errors;
    CUSTOM_DECODE custom_decode;
    int on_flags;
    int off_flags;
    const void* command_name;
    STRLEN command_length;
} redis_fast_async_cb_t;

typedef struct redis_fast_subscribe_cb_s {
    Redis__Fast self;
    SV* cb;
} redis_fast_subscribe_cb_t;


#define WAIT_FOR_READ  0x01
#define WAIT_FOR_WRITE 0x02
typedef struct redis_fast_event_s {
    int flags;
    Redis__Fast self;
} redis_fast_event_t;


static void AddRead(void *privdata) {
    redis_fast_event_t *e = (redis_fast_event_t*)privdata;
    Redis__Fast self = e->self;
    e->flags |= WAIT_FOR_READ;
    DEBUG_MSG("flags = %x", e->flags);
}

static void DelRead(void *privdata) {
    redis_fast_event_t *e = (redis_fast_event_t*)privdata;
    Redis__Fast self = e->self;
    e->flags &= ~WAIT_FOR_READ;
    DEBUG_MSG("flags = %x", e->flags);
}

static void AddWrite(void *privdata) {
    redis_fast_event_t *e = (redis_fast_event_t*)privdata;
    Redis__Fast self = e->self;
    e->flags |= WAIT_FOR_WRITE;
    DEBUG_MSG("flags = %x", e->flags);
}

static void DelWrite(void *privdata) {
    redis_fast_event_t *e = (redis_fast_event_t*)privdata;
    Redis__Fast self = e->self;
    e->flags &= ~WAIT_FOR_WRITE;
    DEBUG_MSG("flags = %x", e->flags);
}

static void Cleanup(void *privdata) {
    free(privdata);
}

static int Attach(redisAsyncContext *ac) {
    Redis__Fast self = (Redis__Fast)ac->data;
    redis_fast_event_t *e;

    /* Nothing should be attached when something is already attached */
    if (ac->ev.data != NULL)
        return REDIS_ERR;

    /* Create container for context and r/w events */
    e = (redis_fast_event_t*)malloc(sizeof(*e));
    e->flags = 0;
    e->self = self;

    /* Register functions to start/stop listening for events */
    ac->ev.addRead = AddRead;
    ac->ev.delRead = DelRead;
    ac->ev.addWrite = AddWrite;
    ac->ev.delWrite = DelWrite;
    ac->ev.cleanup = Cleanup;
    ac->ev.data = e;

    return REDIS_OK;
}

static int wait_for_event(pTHX_ Redis__Fast self, double read_timeout, double write_timeout) {
    redisContext *c;
    int fd;
    redis_fast_event_t *e;
    struct pollfd pollfd;
    int rc;
    double timeout = -1;
    int timeout_mode = WAIT_FOR_EVENT_WRITE_TIMEOUT;
    int ms;

    if(self==NULL) return WAIT_FOR_EVENT_EXCEPTION;
    if(self->ac==NULL) return WAIT_FOR_EVENT_EXCEPTION;

    c = &(self->ac->c);
    fd = c->fd;
    e = (redis_fast_event_t*)self->ac->ev.data;
    if(e==NULL) return 0;

    if((e->flags & (WAIT_FOR_READ|WAIT_FOR_WRITE)) == (WAIT_FOR_READ|WAIT_FOR_WRITE)) {
        DEBUG_MSG("set READ and WRITE, compare read_timeout = %f and write_timeout = %f",
                  read_timeout, write_timeout);
        if(read_timeout < 0 && write_timeout < 0) {
            timeout = -1;
            timeout_mode = WAIT_FOR_EVENT_WRITE_TIMEOUT;
        } else if(read_timeout < 0) {
            timeout = write_timeout;
            timeout_mode = WAIT_FOR_EVENT_WRITE_TIMEOUT;
        } else if(write_timeout < 0) {
            timeout = read_timeout;
            timeout_mode = WAIT_FOR_EVENT_READ_TIMEOUT;
        } else if(read_timeout < write_timeout) {
            timeout = read_timeout;
            timeout_mode = WAIT_FOR_EVENT_READ_TIMEOUT;
        } else {
            timeout = write_timeout;
            timeout_mode = WAIT_FOR_EVENT_WRITE_TIMEOUT;
        }
    } else if(e->flags & WAIT_FOR_READ) {
        DEBUG_MSG("set READ, read_timeout = %f", read_timeout);
        timeout = read_timeout;
        timeout_mode = WAIT_FOR_EVENT_READ_TIMEOUT;
    } else if(e->flags & WAIT_FOR_WRITE) {
        DEBUG_MSG("set WRITE, write_timeout = %f", write_timeout);
        timeout = write_timeout;
        timeout_mode = WAIT_FOR_EVENT_WRITE_TIMEOUT;
    }

  START_POLL:
    if (timeout < 0) {
        ms = -1;
    } else {
        ms = (int)(timeout * 1000 + 0.999);
    }
    DEBUG_MSG("select start, timeout is %f", timeout);
    pollfd.fd = fd;
    pollfd.events = 0;
    pollfd.revents = 0;
    if(e->flags & WAIT_FOR_READ) { pollfd.events |= POLLIN; }
    if(e->flags & WAIT_FOR_WRITE) { pollfd.events |= POLLOUT; }
    rc = poll(&pollfd, 1, ms);
    DEBUG_MSG("poll returns %d", rc);
    if(rc == 0) {
        DEBUG_MSG("%s", "timeout");
        return timeout_mode;
    }

    if(rc < 0) {
        DEBUG_MSG("exception: %s", strerror(errno));
        if( errno == EINTR ) {
            PERL_ASYNC_CHECK();
            DEBUG_MSG("%s", "recieved interrupt. retry wait_for_event");
            goto START_POLL;
        }
        return WAIT_FOR_EVENT_EXCEPTION;
    }
    if(self->ac && (pollfd.revents & POLLIN) != 0) {
        DEBUG_MSG("ready to %s", "read");
        redisAsyncHandleRead(self->ac);
    }
    if(self->ac && (pollfd.revents & (POLLOUT|POLLHUP)) != 0) {
        DEBUG_MSG("ready to %s", "write");
        redisAsyncHandleWrite(self->ac);
    }
    if((pollfd.revents & (POLLERR|POLLNVAL)) != 0) {
        DEBUG_MSG(
            "exception: %s%s",
            (pollfd.revents & POLLERR) ? "POLLERR " : "",
            (pollfd.revents & POLLNVAL) ? "POLLNVAL " : "");
        return WAIT_FOR_EVENT_EXCEPTION;
    }

    DEBUG_MSG("%s", "finish");
    return WAIT_FOR_EVENT_OK;
}


static int _wait_all_responses(pTHX_ Redis__Fast self) {
    DEBUG_MSG("%s", "start");
    while(self->ac && self->ac->replies.tail) {
        int res = wait_for_event(aTHX_ self, self->read_timeout, self->write_timeout);
        if (res != WAIT_FOR_EVENT_OK) {
            DEBUG_MSG("error: %d", res);
            return res;
        }
    }
    DEBUG_MSG("%s", "finish");
    return WAIT_FOR_EVENT_OK;
}


static void Redis__Fast_connect_cb(redisAsyncContext* c, int status) {
    Redis__Fast self = (Redis__Fast)c->data;
    DEBUG_MSG("connected status = %d", status);
    if(status != REDIS_OK) {
        // Connection Error!!
        // Redis context will close automatically
        self->ac = NULL;
    } else {
        self->is_connected = 1;
    }
}

static void Redis__Fast_disconnect_cb(redisAsyncContext* c, int status) {
    Redis__Fast self = (Redis__Fast)c->data;
    PERL_UNUSED_VAR(status);
    DEBUG_MSG("disconnected status = %d", status);
    self->ac = NULL;
}

static redisAsyncContext* __build_sock(pTHX_ Redis__Fast self)
{
    redisAsyncContext *ac;
    double timeout;
    int res;

    DEBUG_MSG("%s", "start");

    if(self->on_build_sock) {
        dSP;

        ENTER;
        SAVETMPS;

        PUSHMARK(SP);
        call_sv(self->on_build_sock, G_DISCARD | G_NOARGS);

        FREETMPS;
        LEAVE;
    }

    if(self->path) {
        ac = redisAsyncConnectUnix(self->path);
    } else {
        ac = redisAsyncConnect(self->hostname, self->port);
    }

    if(ac == NULL) {
        DEBUG_MSG("%s", "allocation error");
        return NULL;
    }
    if(ac->err) {
        DEBUG_MSG("connection error: %s", ac->errstr);
        redisAsyncFree(ac);
        return NULL;
    }

    if(self->ssl){
        redisSSLContext* ssl_context;
        redisSSLContextError ssl_error = REDIS_SSL_CTX_NONE;
        redisSSLOptions options = {
            .cacert_filename      = NULL,
            .capath               = NULL,
            .cert_filename        = NULL,
            .private_key_filename = NULL,
            .server_name          = self->hostname,
            .verify_mode          = self->ssl_verify_mode,
        };
        ssl_context = redisCreateSSLContextWithOptions(&options, &ssl_error);

        if(ssl_context == NULL || ssl_error != REDIS_SSL_CTX_NONE) {
            DEBUG_MSG("ssl context error: %s", redisSSLContextGetError(ssl_error));
            redisAsyncFree(ac);
            redisFreeSSLContext(ssl_context);
            return NULL;
        }

        if (redisInitiateSSLWithContext(&ac->c, ssl_context) != REDIS_OK) {
            DEBUG_MSG("ssl connection error: %s", ac->c.errstr);
            redisAsyncFree(ac);
            redisFreeSSLContext(ssl_context);
            return NULL;
        }
        DEBUG_MSG("%s", "ssl connection setup");
    }

    ac->data = (void*)self;
    self->ac = ac;
    self->is_connected = 0;

    Attach(ac);
    redisAsyncSetConnectCallback(ac, (redisConnectCallback*)Redis__Fast_connect_cb);
    redisAsyncSetDisconnectCallback(ac, (redisDisconnectCallback*)Redis__Fast_disconnect_cb);

    // wait to connect...
    timeout = -1;
    if(self->cnx_timeout) {
        timeout = self->cnx_timeout;
    }
    while(!self->is_connected) {
        res = wait_for_event(aTHX_ self, timeout, timeout);
        if(self->ac == NULL) {
            // set is_connected flag to reconnect.
            // see https://github.com/shogo82148/Redis-Fast/issues/73
            self->is_connected = 1;

            return NULL;
        }
        if(res != WAIT_FOR_EVENT_OK) {
            DEBUG_MSG("error: %d", res);

            // free the redis context
            redisAsyncFree(self->ac);
            _wait_all_responses(aTHX_ self);
            self->ac = NULL;

            // set is_connected flag to reconnect.
            // see https://github.com/shogo82148/Redis-Fast/issues/73
            self->is_connected = 1;

            return NULL;
        }
    }
    if(self->on_connect){
        dSP;
        PUSHMARK(SP);
        call_sv(self->on_connect, G_DISCARD | G_NOARGS);
    }

    DEBUG_MSG("%s", "finish");
    return self->ac;
}


static void Redis__Fast_connect(pTHX_ Redis__Fast self) {
    struct timeval start, end;

    DEBUG_MSG("%s", "start");

    self->flags = 0;

    //$self->{queue} = [];
    self->pid = getpid();

    if(self->reconnect == 0) {
        if(! __build_sock(aTHX_ self)) {
            if(self->path) {
                snprintf(self->error, MAX_ERROR_SIZE, "Could not connect to Redis server at %s", self->path);
            } else {
                snprintf(self->error, MAX_ERROR_SIZE, "Could not connect to Redis server at %s:%d", self->hostname, self->port);
            }
            croak("%s", self->error);
        }
        return ;
    }

    // Reconnect...
    gettimeofday(&start, NULL);
    while (1) {
        double elapsed_time;
        if(__build_sock(aTHX_ self)) {
            // Connected!
            DEBUG_MSG("%s", "finish");
            return;
        }
        gettimeofday(&end, NULL);
        elapsed_time = (end.tv_sec-start.tv_sec) + 1E-6 * (end.tv_usec-start.tv_usec);
        DEBUG_MSG("elapsed time:%f, reconnect:%lf", elapsed_time, self->reconnect);
        if( elapsed_time > self->reconnect) {
            if(self->path) {
                snprintf(self->error, MAX_ERROR_SIZE, "Could not connect to Redis server at %s", self->path);
            } else {
                snprintf(self->error, MAX_ERROR_SIZE, "Could not connect to Redis server at %s:%d", self->hostname, self->port);
            }
            DEBUG_MSG("%s", "timed out");
            croak("%s", self->error);
            return;
        }
        DEBUG_MSG("%s", "failed to connect. wait...");
        usleep(self->every);
    }
    DEBUG_MSG("%s", "finish");
}

// reconnect if the current connection is closed.
// the caller must check self->ac != 0 to continue.
static void Redis__Fast_reconnect(pTHX_ Redis__Fast self) {
    DEBUG_MSG("%s", "start");
    if(self->is_connected && !self->ac && self->reconnect > 0) {
        DEBUG_MSG("%s", "connection not found. reconnect");
        Redis__Fast_connect(aTHX_ self);
    }
    if(!self->ac) {
        DEBUG_MSG("%s", "Not connected to any server");
    }
    DEBUG_MSG("%s", "finish");
}

static redis_fast_reply_t Redis__Fast_decode_reply(pTHX_ Redis__Fast self, redisReply* reply, int collect_errors) {
    redis_fast_reply_t res = {NULL, NULL};

    switch (reply->type) {
    case REDIS_REPLY_ERROR:
        res.error = sv_2mortal(newSVpvn(reply->str, reply->len));
        break;
    case REDIS_REPLY_STRING:
    case REDIS_REPLY_STATUS:
        res.result = sv_2mortal(newSVpvn(reply->str, reply->len));
        break;

    case REDIS_REPLY_INTEGER:
        res.result = sv_2mortal(newSViv(reply->integer));
        break;
    case REDIS_REPLY_NIL:
        res.result = &PL_sv_undef;
        break;

    case REDIS_REPLY_ARRAY: {
        AV* av = newAV();
        size_t i;
        res.result = sv_2mortal(newRV_noinc((SV*)av));

        for (i = 0; i < reply->elements; i++) {
            redis_fast_reply_t elem = Redis__Fast_decode_reply(aTHX_ self, reply->element[i], collect_errors);
            if(collect_errors) {
                AV* elem_av = (AV*)sv_2mortal((SV*)newAV());
                if(elem.result) {
                    av_push(elem_av, SvREFCNT_inc(elem.result));
                } else {
                    av_push(elem_av, newSV(0));
                }
                if(elem.error) {
                    av_push(elem_av, SvREFCNT_inc(elem.error));
                } else {
                    av_push(elem_av, newSV(0));
                }
                av_push(av, newRV_inc((SV*)elem_av));
            } else {
                if(elem.result) {
                    av_push(av, SvREFCNT_inc(elem.result));
                } else {
                    av_push(av, newSV(0));
                }
                if(elem.error && !res.error) {
                    res.error = elem.error;
                }
            }
        }
        break;
    }
    }

    return res;
}

static int Redis__Fast_call_reconnect_on_error(pTHX_ Redis__Fast self, redis_fast_reply_t ret, const void *command_name, STRLEN command_length) {
    int _need_reconnect = 0;
    struct timeval current;
    double current_sec;
    SV* sv_ret;
    SV* sv_err;
    SV* sv_cmd;
    int count;

    if (ret.error == NULL) {
        return _need_reconnect;
    }
    if (self->reconnect_on_error == NULL) {
        return _need_reconnect;
    }

    gettimeofday(&current, NULL);
    current_sec = current.tv_sec + 1E-6 * current.tv_usec;
    if( self->next_reconnect_on_error_at < 0 ||
            self->next_reconnect_on_error_at < current_sec) {
        dSP;
        ENTER;
        SAVETMPS;

        sv_ret = ret.result ? ret.result : &PL_sv_undef;
        sv_err = ret.error;
        sv_cmd = sv_2mortal(newSVpvn((const char*)command_name, command_length));

        PUSHMARK(SP);
        XPUSHs(sv_err);
        XPUSHs(sv_ret);
        XPUSHs(sv_cmd);
        PUTBACK;

        count = call_sv(self->reconnect_on_error, G_SCALAR);

        SPAGAIN;

        if (count != 1) {
            croak("[BUG] retval count should be 1\n");
        }
        _need_reconnect = POPi;

        PUTBACK;
        FREETMPS;
        LEAVE;
    }

    return _need_reconnect;
}

static void Redis__Fast_sync_reply_cb(redisAsyncContext* c, void* reply, void* privdata) {
    dTHX;

    Redis__Fast self = (Redis__Fast)c->data;
    redis_fast_sync_cb_t *cbt = (redis_fast_sync_cb_t*)privdata;
    DEBUG_MSG("%p", (void*)privdata);
    if(reply) {
        self->flags = (self->flags | cbt->on_flags) & cbt->off_flags;
        if(cbt->custom_decode) {
            cbt->ret = (cbt->custom_decode)(aTHX_ self, (redisReply*)reply, cbt->collect_errors);
        } else {
            cbt->ret = Redis__Fast_decode_reply(aTHX_ self, (redisReply*)reply, cbt->collect_errors);
        }
    } else if(c->c.flags & REDIS_FREEING) {
        DEBUG_MSG("%s", "redis freeing");
        Safefree(cbt);
    } else {
        DEBUG_MSG("connect error: %s", c->errstr);
        self->need_reconnect = 1;
        cbt->ret.result = NULL;
        cbt->ret.error = sv_2mortal( newSVpvn(c->errstr, strlen(c->errstr)) );
    }
    DEBUG_MSG("%s", "finish");
}

static void Redis__Fast_async_reply_cb(redisAsyncContext* c, void* reply, void* privdata) {
    dTHX;

    Redis__Fast self = (Redis__Fast)c->data;
    redis_fast_async_cb_t *cbt = (redis_fast_async_cb_t*)privdata;
    DEBUG_MSG("%p, %p", reply, privdata);
    if (reply) {
        self->flags = (self->flags | cbt->on_flags) & cbt->off_flags;

        {
            redis_fast_reply_t result;

            dSP;

            ENTER;
            SAVETMPS;

            if(cbt->custom_decode) {
                result = (cbt->custom_decode)(aTHX_ self, (redisReply*)reply, cbt->collect_errors);
            } else {
                result = Redis__Fast_decode_reply(aTHX_ self, (redisReply*)reply, cbt->collect_errors);
            }

            if(result.result == NULL) result.result = &PL_sv_undef;
            if(result.error == NULL) result.error = &PL_sv_undef;

            PUSHMARK(SP);
            XPUSHs(result.result);
            XPUSHs(result.error);
            PUTBACK;

            call_sv(cbt->cb, G_DISCARD);

            FREETMPS;
            LEAVE;
        }

        {
            if (0 < self->reconnect && !self->need_reconnect
                // Avoid useless cost when reconnect_on_error is not set.
                && self->reconnect_on_error != NULL) {
                redis_fast_reply_t result;
                if(cbt->custom_decode) {
                    result = (cbt->custom_decode)(
                        aTHX_ self, (redisReply*)reply, cbt->collect_errors
                    );
                } else {
                    result = Redis__Fast_decode_reply(
                        aTHX_ self, (redisReply*)reply, cbt->collect_errors
                    );
                }
                self->need_reconnect = Redis__Fast_call_reconnect_on_error(
                    aTHX_ self, result, cbt->command_name, cbt->command_length
                );
            }
        }
    } else {
        if (c->c.flags & REDIS_FREEING) {
             DEBUG_MSG("%s", "redis freeing");
        } else {
            DEBUG_MSG("connect error: %s", c->errstr);
        }

        {
            redis_fast_reply_t result;
            const char *msg;

            dSP;

            ENTER;
            SAVETMPS;

            result.result = &PL_sv_undef;
            if (c->c.flags & REDIS_FREEING) {
                msg = "redis freeing";
            } else {
                msg = c->errstr;
            }
            DEBUG_MSG("error: %s", msg);
            result.error = sv_2mortal(newSVpvn(msg, strlen(msg)));

            PUSHMARK(SP);
            XPUSHs(result.result);
            XPUSHs(result.error);
            PUTBACK;

            call_sv(cbt->cb, G_DISCARD);

            FREETMPS;
            LEAVE;
        }
    }

    SvREFCNT_dec(cbt->cb);
    Safefree(cbt);
}

static void Redis__Fast_subscribe_cb(redisAsyncContext* c, void* reply, void* privdata) {
    dTHX;

    int is_need_free = 0;
    Redis__Fast self = (Redis__Fast)c->data;
    redis_fast_subscribe_cb_t *cbt = (redis_fast_subscribe_cb_t*)privdata;
    redisReply* r = (redisReply*)reply;

    DEBUG_MSG("%s", "start");
    if(!cbt) {
        DEBUG_MSG("%s", "cbt is empty finished");
        return ;
    }

    if (r) {
        char* stype = r->element[0]->str;
        int pvariant = (tolower(stype[0]) == 'p') ? 1 : 0;
        redis_fast_reply_t res;

        dSP;
        ENTER;
        SAVETMPS;

        res = Redis__Fast_decode_reply(aTHX_ self, r, 0);

        if (strcasecmp(stype+pvariant,"subscribe") == 0) {
            DEBUG_MSG("%s %s %lld", r->element[0]->str, r->element[1]->str, r->element[2]->integer);
            self->is_subscriber = r->element[2]->integer;
            self->expected_subs--;
        } else if (strcasecmp(stype+pvariant,"unsubscribe") == 0) {
            DEBUG_MSG("%s %s %lld", r->element[0]->str, r->element[1]->str, r->element[2]->integer);
            self->is_subscriber = r->element[2]->integer;
            is_need_free = 1;
            self->expected_subs--;
        } else {
            DEBUG_MSG("%s %s", r->element[0]->str, r->element[1]->str);
            self->proccess_sub_count++;
        }

        if(res.result == NULL) res.result = &PL_sv_undef;
        if(res.error == NULL) res.error = &PL_sv_undef;

        PUSHMARK(SP);
        XPUSHs(res.result);
        XPUSHs(res.error);
        PUTBACK;

        call_sv(cbt->cb, G_DISCARD);

        FREETMPS;
        LEAVE;
    } else {
        DEBUG_MSG("connect error: %s", c->errstr);
        is_need_free = 1;
    }

    if(is_need_free) {
        // destroy private data
        DEBUG_MSG("destroy %p", cbt);
        if(cbt->cb) {
            SvREFCNT_dec(cbt->cb);
            cbt->cb = NULL;
        }
        Safefree(cbt);
    }
    DEBUG_MSG("%s", "finish");
}

static void Redis__Fast_quit(pTHX_ Redis__Fast self) {
    redis_fast_sync_cb_t *cbt;

    if(!self->ac) {
        return;
    }

    Newx(cbt, sizeof(redis_fast_sync_cb_t), redis_fast_sync_cb_t);
    cbt->ret.result = NULL;
    cbt->ret.error = NULL;
    cbt->custom_decode = NULL;

    // initialize, or self->flags will be corrupted.
    cbt->on_flags = 0;
    cbt->off_flags = 0;

    redisAsyncCommand(
        self->ac, Redis__Fast_sync_reply_cb, cbt, "QUIT"
        );
    redisAsyncDisconnect(self->ac);
    if(_wait_all_responses(aTHX_ self) == WAIT_FOR_EVENT_OK) {
        DEBUG_MSG("%s", "wait_all_responses ok");
        if(cbt->ret.result || cbt->ret.error) Safefree(cbt);
    } else {
        DEBUG_MSG("%s", "wait_all_responses not ok");
        if(cbt->ret.result || cbt->ret.error) Safefree(cbt);
    }
    DEBUG_MSG("%s", "finish");
}

static redis_fast_reply_t  Redis__Fast_run_cmd(pTHX_ Redis__Fast self, int collect_errors, CUSTOM_DECODE custom_decode, SV* cb, int argc, const char** argv, size_t* argvlen) {
    redis_fast_reply_t ret = {NULL, NULL};
    int on_flags = 0, off_flags = ~0;

    DEBUG_MSG("start %s", argv[0]);

    DEBUG_MSG("pid check: previous pid is %d, now %d", self->pid, getpid());
    if(self->pid != getpid()) {
        DEBUG_MSG("%s", "pid changed. create new connection..");
        Redis__Fast_connect(aTHX_ self);
    }

    if(EQUALS_COMMAND(argvlen[0], argv[0], "MULTI")) {
        on_flags = FLAG_INSIDE_TRANSACTION;
    } else if(EQUALS_COMMAND(argvlen[0], argv[0], "EXEC") ||
              EQUALS_COMMAND(argvlen[0], argv[0], "DISCARD")) {
        off_flags = ~(FLAG_INSIDE_TRANSACTION | FLAG_INSIDE_WATCH);
    } else if(EQUALS_COMMAND(argvlen[0], argv[0], "WATCH")) {
        on_flags = FLAG_INSIDE_WATCH;
    } else if(EQUALS_COMMAND(argvlen[0], argv[0], "UNWATCH")) {
        off_flags = ~FLAG_INSIDE_WATCH;
    }

    if(cb) {
        redis_fast_async_cb_t *cbt;
        Newx(cbt, sizeof(redis_fast_async_cb_t), redis_fast_async_cb_t);
        cbt->cb = SvREFCNT_inc(cb);
        cbt->custom_decode = custom_decode;
        cbt->collect_errors = collect_errors;
        cbt->on_flags = on_flags;
        cbt->off_flags = off_flags;
        cbt->command_name = argv[0];
        cbt->command_length = argvlen[0];
        redisAsyncCommandArgv(
            self->ac, Redis__Fast_async_reply_cb, cbt,
            argc, argv, argvlen
            );
        ret.result = sv_2mortal(newSViv(1));
    } else {
        redis_fast_sync_cb_t *cbt;
        int i, cnt = (self->reconnect == 0 ? 1 : 2);
        int res = WAIT_FOR_EVENT_OK;
        for(i = 0; i < cnt; i++) {
            Newx(cbt, sizeof(redis_fast_sync_cb_t), redis_fast_sync_cb_t);
            self->need_reconnect = 0;
            cbt->ret.result = NULL;
            cbt->ret.error = NULL;
            cbt->custom_decode = custom_decode;
            cbt->collect_errors = collect_errors;
            cbt->on_flags = on_flags;
            cbt->off_flags = off_flags;
            DEBUG_MSG("%s", "send command in sync mode");
            redisAsyncCommandArgv(
                self->ac, Redis__Fast_sync_reply_cb, cbt,
                argc, argv, argvlen
                );
            DEBUG_MSG("%s", "waiting response");
            res = _wait_all_responses(aTHX_ self);
            if(res == WAIT_FOR_EVENT_OK && self->need_reconnect == 0) {
                int _need_reconnect = 0;
                if (1 < cnt - i) {
                    _need_reconnect = Redis__Fast_call_reconnect_on_error(
                        aTHX_ self, cbt->ret, argv[0], argvlen[0]
                    );
                    // Should be quit before reconnect
                    if (_need_reconnect) {
                        Redis__Fast_quit(aTHX_ self);
                    }
                }
                if (!_need_reconnect) {
                    ret = cbt->ret;
                    if(cbt->ret.result || cbt->ret.error) Safefree(cbt);
                    DEBUG_MSG("finish %s", argv[0]);
                    return ret;
                }
            }

            if( res == WAIT_FOR_EVENT_READ_TIMEOUT ) break;

            if(self->flags & (FLAG_INSIDE_TRANSACTION | FLAG_INSIDE_WATCH)) {
                char *msg = "reconnect disabled inside transaction or watch";
                DEBUG_MSG("error: %s", msg);
                ret.error = sv_2mortal(newSVpvn(msg, strlen(msg)));
                return ret;
            }

            Redis__Fast_reconnect(aTHX_ self);
            if(!self->ac) {
                char *msg = "Not connected to any server";
                DEBUG_MSG("error: %s", msg);
                ret.error = sv_2mortal(newSVpvn(msg, strlen(msg)));
                return ret;
            }
        }

        if( res == WAIT_FOR_EVENT_OK && (cbt->ret.result || cbt->ret.error) ) Safefree(cbt);
        // else destructor will release cbt

        if(res == WAIT_FOR_EVENT_READ_TIMEOUT || res == WAIT_FOR_EVENT_WRITE_TIMEOUT) {
            snprintf(self->error, MAX_ERROR_SIZE, "Error while reading from Redis server: %s", strerror(EAGAIN));
            errno = EAGAIN;
            DEBUG_MSG("error: %s", self->error);
            ret.error = sv_2mortal(newSVpvn(self->error, strlen(self->error)));
            return ret;
        }
        if(!self->ac) {
            char *msg = "Not connected to any server";
            DEBUG_MSG("error: %s", msg);
            ret.error = sv_2mortal(newSVpvn(msg, strlen(msg)));
            return ret;
        }
    }
    DEBUG_MSG("Finish %s", argv[0]);
    return ret;
}

static redis_fast_reply_t Redis__Fast_keys_custom_decode(pTHX_ Redis__Fast self, redisReply* reply, int collect_errors) {
    // TODO: Support redis <= 1.2.6
    return Redis__Fast_decode_reply(aTHX_ self, reply, collect_errors);
}

static redis_fast_reply_t Redis__Fast_info_custom_decode(pTHX_ Redis__Fast self, redisReply* reply, int collect_errors) {
    redis_fast_reply_t res = {NULL, NULL};

    if(reply->type == REDIS_REPLY_STRING ||
       reply->type == REDIS_REPLY_STATUS) {

        HV* hv = newHV();
        char* str = reply->str;
        size_t len = reply->len;
        res.result = sv_2mortal(newRV_noinc((SV*)hv));

        while(len != 0) {
            const char* line = (char*)memchr(str, '\r', len);
            const char* sep;
            size_t linelen;
            if(line == NULL) {
                linelen = len;
            } else {
                linelen = line - str;
            }
            sep = (char*)memchr(str, ':', linelen);
            if(str[0] != '#' && sep != NULL) {
                SV* val;
                SV** ret;
                size_t keylen;
                keylen = sep - str;
                val = sv_2mortal(newSVpvn(sep + 1, linelen - keylen - 1));
                ret = hv_store(hv, str, keylen, SvREFCNT_inc(val), 0);
                if (ret == NULL) {
                    SvREFCNT_dec(val);
                    croak("failed to hv_store");
                }
            }
            if(line == NULL) {
                break;
            } else {
                len -= linelen + 2;
                str += linelen + 2;
            }
        }
    } else {
        res = Redis__Fast_decode_reply(aTHX_ self, reply, collect_errors);
    }

    return res;
}

#line 974 "lib/Redis/Fast.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1118 "lib/Redis/Fast.c"

XS_EUPXS(XS_Redis__Fast__new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast__new)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "cls");
    {
#line 969 "lib/Redis/Fast.xs"
redis_fast_t* self;
#line 1129 "lib/Redis/Fast.c"
	SV *	RETVAL;
	char*	cls = (char *)SvPV_nolen(ST(0))
;
#line 971 "lib/Redis/Fast.xs"
{
    redisInitOpenSSL();
    Newxz(self, sizeof(redis_fast_t), redis_fast_t);
    DEBUG_MSG("%s", "start");
    self->error = (char*)malloc(MAX_ERROR_SIZE);
    self->reconnect_on_error = NULL;
    self->next_reconnect_on_error_at = -1;
    self->is_connected = 1;
    ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), cls, (void*)self);
    DEBUG_MSG("return %p", ST(0));
    XSRETURN(1);
}
#line 1147 "lib/Redis/Fast.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_reconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_reconnect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	double	val = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_reconnect",
			"self", "Redis::Fast")
;
#line 990 "lib/Redis/Fast.xs"
{
    RETVAL = self->reconnect = val;
}
#line 1181 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___get_reconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_reconnect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_reconnect",
			"self", "Redis::Fast")
;
#line 1000 "lib/Redis/Fast.xs"
{
    RETVAL = self->reconnect;
}
#line 1212 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_every); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_every)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	int	val = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_every",
			"self", "Redis::Fast")
;
#line 1010 "lib/Redis/Fast.xs"
{
    RETVAL = self->every = val;
}
#line 1245 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___get_every); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_every)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_every",
			"self", "Redis::Fast")
;
#line 1020 "lib/Redis/Fast.xs"
{
    RETVAL = self->every;
}
#line 1276 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_debug); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_debug)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	int	val = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_debug",
			"self", "Redis::Fast")
;
#line 1029 "lib/Redis/Fast.xs"
{
    RETVAL = self->debug = val;
}
#line 1309 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_cnx_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_cnx_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	double	val = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_cnx_timeout",
			"self", "Redis::Fast")
;
#line 1038 "lib/Redis/Fast.xs"
{
    RETVAL = self->cnx_timeout = val;
}
#line 1342 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___get_cnx_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_cnx_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_cnx_timeout",
			"self", "Redis::Fast")
;
#line 1047 "lib/Redis/Fast.xs"
{
    RETVAL = self->cnx_timeout;
}
#line 1373 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_read_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_read_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	double	val = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_read_timeout",
			"self", "Redis::Fast")
;
#line 1057 "lib/Redis/Fast.xs"
{
    RETVAL = self->read_timeout = val;
}
#line 1406 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___get_read_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_read_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_read_timeout",
			"self", "Redis::Fast")
;
#line 1066 "lib/Redis/Fast.xs"
{
    RETVAL = self->read_timeout;
}
#line 1437 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_write_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_write_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	double	val = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_write_timeout",
			"self", "Redis::Fast")
;
#line 1076 "lib/Redis/Fast.xs"
{
    RETVAL = self->write_timeout = val;
}
#line 1470 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___get_write_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_write_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_write_timeout",
			"self", "Redis::Fast")
;
#line 1085 "lib/Redis/Fast.xs"
{
    RETVAL = self->write_timeout;
}
#line 1501 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_current_database); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_current_database)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	int	val = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_current_database",
			"self", "Redis::Fast")
;
#line 1095 "lib/Redis/Fast.xs"
{
    RETVAL = self->current_database = val;
}
#line 1534 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___get_current_database); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_current_database)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_current_database",
			"self", "Redis::Fast")
;
#line 1105 "lib/Redis/Fast.xs"
{
    RETVAL = self->current_database;
}
#line 1565 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___sock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___sock)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__sock",
			"self", "Redis::Fast")
;
#line 1115 "lib/Redis/Fast.xs"
{
    RETVAL = self->ac ? self->ac->c.fd : 0;
}
#line 1596 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___get_port); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_port)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_port",
			"self", "Redis::Fast")
;
#line 1125 "lib/Redis/Fast.xs"
{
    struct sockaddr_in addr;
    socklen_t len;
    len = sizeof( addr );
    getsockname( self->ac->c.fd, ( struct sockaddr *)&addr, &len );
    RETVAL = addr.sin_port;
}
#line 1631 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_on_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_on_connect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, func");
    {
	Redis__Fast	self;
	SV*	func = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_on_connect",
			"self", "Redis::Fast")
;
#line 1139 "lib/Redis/Fast.xs"
{
    self->on_connect = SvREFCNT_inc(func);
}
#line 1662 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast___set_on_build_sock); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_on_build_sock)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, func");
    {
	Redis__Fast	self;
	SV*	func = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_on_build_sock",
			"self", "Redis::Fast")
;
#line 1146 "lib/Redis/Fast.xs"
{
    self->on_build_sock = SvREFCNT_inc(func);
}
#line 1692 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast___set_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_data)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, data");
    {
	Redis__Fast	self;
	SV*	data = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_data",
			"self", "Redis::Fast")
;
#line 1153 "lib/Redis/Fast.xs"
{
    self->data = SvREFCNT_inc(data);
}
#line 1722 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast___get_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___get_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__get_data",
			"self", "Redis::Fast")
;
#line 1160 "lib/Redis/Fast.xs"
{
    ST(0) = self->data;
    XSRETURN(1);
}
#line 1751 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_reconnect_on_error); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_reconnect_on_error)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, func");
    {
	Redis__Fast	self;
	SV*	func = ST(1)
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_reconnect_on_error",
			"self", "Redis::Fast")
;
#line 1168 "lib/Redis/Fast.xs"
{
    self->reconnect_on_error = SvREFCNT_inc(func);
}
#line 1781 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast___set_next_reconnect_on_error_at); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_next_reconnect_on_error_at)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, val");
    {
	double	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	double	val = (double)SvNV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_next_reconnect_on_error_at",
			"self", "Redis::Fast")
;
#line 1175 "lib/Redis/Fast.xs"
{
    struct timeval current;
    double current_sec;

    if ( -1 < val ) {
        gettimeofday(&current, NULL);
        current_sec = current.tv_sec + 1E-6 * current.tv_usec;
        val += current_sec;
    }

    RETVAL = self->next_reconnect_on_error_at = val;
}
#line 1822 "lib/Redis/Fast.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_ssl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_ssl)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, ssl");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	int	ssl = (int)SvIV(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_ssl",
			"self", "Redis::Fast")
;
#line 1193 "lib/Redis/Fast.xs"
{
    RETVAL = self->ssl = ssl;
}
#line 1855 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___set_ssl_verify_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___set_ssl_verify_mode)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, verify_mode");
    {
	int	RETVAL;
	dXSTARG;
	Redis__Fast	self;
	char*	verify_mode = (char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__set_ssl_verify_mode",
			"self", "Redis::Fast")
;
#line 1202 "lib/Redis/Fast.xs"
{
    if (verify_mode != NULL) {
        DEBUG_MSG("SSL verify mode: %s", verify_mode);
        if (strcmp(verify_mode, "SSL_VERIFY_NONE") == 0 ) {
            RETVAL = self->ssl_verify_mode = REDIS_SSL_VERIFY_NONE;
        } else if (strcmp(verify_mode, "SSL_VERIFY_PEER") == 0 ) {
            RETVAL = self->ssl_verify_mode = REDIS_SSL_VERIFY_PEER;
        } else if (strcmp(verify_mode, "SSL_VERIFY_FAIL_IF_NO_PEER_CERT") == 0 ) {
            RETVAL = self->ssl_verify_mode = REDIS_SSL_VERIFY_FAIL_IF_NO_PEER_CERT;
        } else if (strcmp(verify_mode, "SSL_VERIFY_CLIENT_ONCE") == 0 ) {
            RETVAL = self->ssl_verify_mode = REDIS_SSL_VERIFY_CLIENT_ONCE;
        } else {
            DEBUG_MSG("Invalid SSL verify mode (%s), setting SSL_VERIFY_PEER", verify_mode);
            RETVAL = self->ssl_verify_mode = REDIS_SSL_VERIFY_PEER;
        }
    } else {
        RETVAL = self->ssl_verify_mode = REDIS_SSL_VERIFY_PEER;
    }
}
#line 1904 "lib/Redis/Fast.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast_is_subscriber); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast_is_subscriber)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::is_subscriber",
			"self", "Redis::Fast")
;
#line 1227 "lib/Redis/Fast.xs"
{
    ST(0) = sv_2mortal(newSViv(self->is_subscriber));
    XSRETURN(1);
}
#line 1934 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Redis::Fast::DESTROY",
			"self")
;
#line 1236 "lib/Redis/Fast.xs"
{
    DEBUG_MSG("%s", "start");
    if (self->ac) {
        DEBUG_MSG("%s", "free ac");
        redisAsyncFree(self->ac);
        _wait_all_responses(aTHX_ self);
        self->ac = NULL;
    }

    if(self->hostname) {
        DEBUG_MSG("%s", "free hostname");
        free(self->hostname);
        self->hostname = NULL;
    }

    if(self->path) {
        DEBUG_MSG("%s", "free path");
        free(self->path);
        self->path = NULL;
    }

    if(self->error) {
        DEBUG_MSG("%s", "free error");
        free(self->error);
        self->error = NULL;
    }

    if(self->on_connect) {
        DEBUG_MSG("%s", "free on_connect");
        SvREFCNT_dec(self->on_connect);
        self->on_connect = NULL;
    }

    if(self->on_build_sock) {
        DEBUG_MSG("%s", "free on_build_sock");
        SvREFCNT_dec(self->on_build_sock);
        self->on_build_sock = NULL;
    }

    if(self->data) {
        DEBUG_MSG("%s", "free data");
        SvREFCNT_dec(self->data);
        self->data = NULL;
    }

    if(self->reconnect_on_error) {
        DEBUG_MSG("%s", "free reconnect_on_error");
        SvREFCNT_dec(self->reconnect_on_error);
        self->reconnect_on_error = NULL;
    }

    DEBUG_MSG("%s", "finish");
    Safefree(self);
}
#line 2013 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast___connection_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___connection_info)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "self, hostname, port= 6379");
    {
	Redis__Fast	self;
	char*	hostname = (char *)SvPV_nolen(ST(1))
;
	int	port;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__connection_info",
			"self", "Redis::Fast")
;

	if (items < 3)
	    port = 6379;
	else {
	    port = (int)SvIV(ST(2))
;
	}
#line 1295 "lib/Redis/Fast.xs"
{
    if(self->hostname) {
        free(self->hostname);
        self->hostname = NULL;
    }

    if(self->path) {
        free(self->path);
        self->path = NULL;
    }

    if(hostname) {
        self->hostname = (char*)malloc(strlen(hostname) + 1);
        strcpy(self->hostname, hostname);
    }

    self->port = port;
}
#line 2066 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast___connection_info_unix); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___connection_info_unix)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, path");
    {
	Redis__Fast	self;
	char*	path = (char *)SvPV_nolen(ST(1))
;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__connection_info_unix",
			"self", "Redis::Fast")
;
#line 1317 "lib/Redis/Fast.xs"
{
    if(self->hostname) {
        free(self->hostname);
        self->hostname = NULL;
    }

    if(self->path) {
        free(self->path);
        self->path = NULL;
    }

    if(path) {
        self->path = (char*)malloc(strlen(path) + 1);
        strcpy(self->path, path);
    }
}
#line 2109 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast_connect)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::connect",
			"self", "Redis::Fast")
;
#line 1338 "lib/Redis/Fast.xs"
{
    Redis__Fast_connect(aTHX_ self);
}
#line 2137 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast_wait_all_responses); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast_wait_all_responses)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::wait_all_responses",
			"self", "Redis::Fast")
;
#line 1345 "lib/Redis/Fast.xs"
{
    int res = _wait_all_responses(aTHX_ self);
    if(res != WAIT_FOR_EVENT_OK) {
        croak("Error while reading from Redis server");
    }

    if (0 < self->reconnect && self->need_reconnect) {
        // Should be quit before reconnect
        Redis__Fast_quit(aTHX_ self);
        Redis__Fast_reconnect(aTHX_ self);
        self->need_reconnect = 0;
    }
}
#line 2175 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast_wait_one_response); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast_wait_one_response)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::wait_one_response",
			"self", "Redis::Fast")
;
#line 1362 "lib/Redis/Fast.xs"
{
    int res = _wait_all_responses(aTHX_ self);
    if(res != WAIT_FOR_EVENT_OK) {
        croak("Error while reading from Redis server");
    }

    if (0 < self->reconnect && self->need_reconnect) {
        // Should be quit before reconnect
        Redis__Fast_quit(aTHX_ self);
        Redis__Fast_reconnect(aTHX_ self);
        self->need_reconnect = 0;
    }
}
#line 2213 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast___std_cmd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___std_cmd)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
#line 1379 "lib/Redis/Fast.xs"
    redis_fast_reply_t ret;
    SV* cb;
    char** argv;
    size_t* argvlen;
    STRLEN len;
    int argc, i, collect_errors;
#line 2233 "lib/Redis/Fast.c"
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__std_cmd",
			"self", "Redis::Fast")
;
#line 1386 "lib/Redis/Fast.xs"
{
    Redis__Fast_reconnect(aTHX_ self);
    if(!self->ac) {
        croak("Not connected to any server");
    }

    cb = ST(items - 1);
    if (SvROK(cb) && SvTYPE(SvRV(cb)) == SVt_PVCV) {
        argc = items - 2;
    } else {
        cb = NULL;
        argc = items - 1;
    }
    Newx(argv, sizeof(char*) * argc, char*);
    Newx(argvlen, sizeof(size_t) * argc, size_t);

    for (i = 0; i < argc; i++) {
        if(!sv_utf8_downgrade(ST(i + 1), 1)) {
            croak("command sent is not an octet sequence in the native encoding (Latin-1). Consider using debug mode to see the command itself.");
        }
        argv[i] = SvPV(ST(i + 1), len);
        argvlen[i] = len;
    }

    collect_errors = 0;
    if(cb && EQUALS_COMMAND(argvlen[0], argv[0], "EXEC"))
        collect_errors = 1;

    ret = Redis__Fast_run_cmd(aTHX_ self, collect_errors, NULL, cb, argc, (const char**)argv, argvlen);

    Safefree(argv);
    Safefree(argvlen);

    ST(0) = ret.result ? ret.result : &PL_sv_undef;
    ST(1) = ret.error ? ret.error : &PL_sv_undef;
    XSRETURN(2);
}
#line 2283 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___quit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___quit)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__quit",
			"self", "Redis::Fast")
;
#line 1428 "lib/Redis/Fast.xs"
{
    DEBUG_MSG("%s", "start QUIT");
    if(self->ac) {
        Redis__Fast_quit(aTHX_ self);
        ST(0) = sv_2mortal(newSViv(1));
        XSRETURN(1);
    } else {
        DEBUG_MSG("%s", "finish. there is no connection.");
        XSRETURN(0);
    }
}
#line 2319 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___shutdown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___shutdown)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__shutdown",
			"self", "Redis::Fast")
;
#line 1444 "lib/Redis/Fast.xs"
{
    DEBUG_MSG("%s", "start SHUTDOWN");
    if(self->ac) {
        redisAsyncCommand(
            self->ac, NULL, NULL, "SHUTDOWN"
            );
        redisAsyncDisconnect(self->ac);
        _wait_all_responses(aTHX_ self);
        self->is_connected = 0;
        ST(0) = sv_2mortal(newSViv(1));
        XSRETURN(1);
    } else {
        DEBUG_MSG("%s", "redis server has alread shutdown");
        XSRETURN(0);
    }
}
#line 2360 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___keys); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___keys)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
#line 1465 "lib/Redis/Fast.xs"
    redis_fast_reply_t ret;
    SV* cb;
    char** argv;
    size_t* argvlen;
    STRLEN len;
    int argc, i;
#line 2380 "lib/Redis/Fast.c"
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__keys",
			"self", "Redis::Fast")
;
#line 1472 "lib/Redis/Fast.xs"
{
    Redis__Fast_reconnect(aTHX_ self);
    if(!self->ac) {
        croak("Not connected to any server");
    }

    cb = ST(items - 1);
    if (SvROK(cb) && SvTYPE(SvRV(cb)) == SVt_PVCV) {
        argc = items - 1;
    } else {
        cb = NULL;
        argc = items;
    }
    Newx(argv, sizeof(char*) * argc, char*);
    Newx(argvlen, sizeof(size_t) * argc, size_t);

    argv[0] = "KEYS";
    argvlen[0] = 4;
    for (i = 1; i < argc; i++) {
        argv[i] = SvPV(ST(i), len);
        argvlen[i] = len;
    }

    ret = Redis__Fast_run_cmd(aTHX_ self, 0, Redis__Fast_keys_custom_decode, cb, argc, (const char**)argv, argvlen);
    Safefree(argv);
    Safefree(argvlen);

    ST(0) = ret.result ? ret.result : &PL_sv_undef;
    ST(1) = ret.error ? ret.error : &PL_sv_undef;
    XSRETURN(2);
}
#line 2424 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___info)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
#line 1508 "lib/Redis/Fast.xs"
    redis_fast_reply_t ret;
    SV* cb;
    char** argv;
    size_t* argvlen;
    STRLEN len;
    int argc, i;
#line 2444 "lib/Redis/Fast.c"
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__info",
			"self", "Redis::Fast")
;
#line 1515 "lib/Redis/Fast.xs"
{
    Redis__Fast_reconnect(aTHX_ self);
    if(!self->ac) {
        char *msg = "Not connected to any server";
        ST(0) = &PL_sv_undef;
        ST(1) = sv_2mortal(newSVpvn(msg, strlen(msg)));
        XSRETURN(2);
    }

    cb = ST(items - 1);
    if (SvROK(cb) && SvTYPE(SvRV(cb)) == SVt_PVCV) {
        argc = items - 1;
    } else {
        cb = NULL;
        argc = items;
    }
    Newx(argv, sizeof(char*) * argc, char*);
    Newx(argvlen, sizeof(size_t) * argc, size_t);

    argv[0] = "INFO";
    argvlen[0] = 4;
    for (i = 1; i < argc; i++) {
        argv[i] = SvPV(ST(i), len);
        argvlen[i] = len;
    }

    ret = Redis__Fast_run_cmd(aTHX_ self, 0, Redis__Fast_info_custom_decode, cb, argc, (const char**)argv, argvlen);
    Safefree(argv);
    Safefree(argvlen);

    ST(0) = ret.result ? ret.result : &PL_sv_undef;
    ST(1) = ret.error ? ret.error : &PL_sv_undef;
    XSRETURN(2);
}
#line 2491 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___send_subscription_cmd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___send_subscription_cmd)
{
    dVAR; dXSARGS;
    if (items < 1)
       croak_xs_usage(cv,  "self, ...");
    {
#line 1554 "lib/Redis/Fast.xs"
    SV* cb;
    char** argv;
    size_t* argvlen;
    STRLEN len;
    int argc, i;
    redis_fast_subscribe_cb_t* cbt;
    int pvariant;
#line 2512 "lib/Redis/Fast.c"
	Redis__Fast	self;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__send_subscription_cmd",
			"self", "Redis::Fast")
;
#line 1562 "lib/Redis/Fast.xs"
{
    int cnt = (self->reconnect == 0 ? 1 : 2);

    DEBUG_MSG("%s", "start");

    Redis__Fast_reconnect(aTHX_ self);
    if(!self->ac) {
        croak("Not connected to any server");
    }

    if(!self->is_subscriber) {
        _wait_all_responses(aTHX_ self);
    }
    cb = ST(items - 1);
    if (SvROK(cb) && SvTYPE(SvRV(cb)) == SVt_PVCV) {
        argc = items - 2;
    } else {
        cb = NULL;
        argc = items - 1;
    }
    Newx(argv, sizeof(char*) * argc, char*);
    Newx(argvlen, sizeof(size_t) * argc, size_t);

    for (i = 0; i < argc; i++) {
        argv[i] = SvPV(ST(i+1), len);
        argvlen[i] = len;
        DEBUG_MSG("argv[%d] = %s", i, argv[i]);
    }

    for(i = 0; i < cnt; i++) {
        pvariant = tolower(argv[0][0]) == 'p';
        if (strcasecmp(argv[0]+pvariant,"unsubscribe") != 0) {
            DEBUG_MSG("%s", "command is not unsubscribe");
            Newx(cbt, sizeof(redis_fast_subscribe_cb_t), redis_fast_subscribe_cb_t);
            cbt->self = self;
            cbt->cb = SvREFCNT_inc(cb);
        } else {
            DEBUG_MSG("%s", "command is unsubscribe");
            cbt = NULL;
        }
        redisAsyncCommandArgv(
            self->ac, cbt ? Redis__Fast_subscribe_cb : NULL, cbt,
            argc, (const char**)argv, argvlen
            );
        self->expected_subs = argc - 1;
        while(self->expected_subs > 0 && wait_for_event(aTHX_ self, self->read_timeout, self->write_timeout) == WAIT_FOR_EVENT_OK) ;
        if(self->expected_subs == 0) break;
        Redis__Fast_reconnect(aTHX_ self);
        if(!self->ac) {
            Safefree(argv);
            Safefree(argvlen);
            croak("Not connected to any server");
        }
    }

    Safefree(argv);
    Safefree(argvlen);
    DEBUG_MSG("%s", "finish");
    XSRETURN(0);
}
#line 2585 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Redis__Fast_wait_for_messages); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast_wait_for_messages)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, timeout= -1");
    {
	Redis__Fast	self;
	double	timeout;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::wait_for_messages",
			"self", "Redis::Fast")
;

	if (items < 2)
	    timeout = -1;
	else {
	    timeout = (double)SvNV(ST(1))
;
	}
#line 1626 "lib/Redis/Fast.xs"
{
    int i, cnt = (self->reconnect == 0 ? 1 : 2);
    int res = WAIT_FOR_EVENT_OK;
    DEBUG_MSG("%s", "start");
    self->proccess_sub_count = 0;
    for(i = 0; i < cnt; i++) {
        while((res = wait_for_event(aTHX_ self, timeout, timeout)) == WAIT_FOR_EVENT_OK) ;
        if(res == WAIT_FOR_EVENT_READ_TIMEOUT || res == WAIT_FOR_EVENT_WRITE_TIMEOUT) break;
        Redis__Fast_reconnect(aTHX_ self);
        if(!self->ac) {
            croak("Not connected to any server");
        }
    }
    if(res == WAIT_FOR_EVENT_EXCEPTION) {
        if(!self->ac) {
            DEBUG_MSG("%s", "Connection not found");
            croak("EOF from server");
        } else if(self->ac->c.err == REDIS_ERR_EOF) {
            DEBUG_MSG("hiredis returns error: %s", self->ac->c.errstr);
            croak("EOF from server");
        } else {
            DEBUG_MSG("hiredis returns error: %s", self->ac->c.errstr);
            snprintf(self->error, MAX_ERROR_SIZE, "[WAIT_FOR_MESSAGES] %s", self->ac->c.errstr);
            croak("%s", self->error);
        }
    }
    ST(0) = sv_2mortal(newSViv(self->proccess_sub_count));
    DEBUG_MSG("finish with %d", res);
    XSRETURN(1);
}
#line 2648 "lib/Redis/Fast.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Redis__Fast___wait_for_event); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Redis__Fast___wait_for_event)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "self, timeout= -1");
    {
	Redis__Fast	self;
	double	timeout;

	if (SvROK(ST(0)) && sv_derived_from(ST(0), "Redis::Fast")) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    self = INT2PTR(Redis__Fast,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not of type %s",
			"Redis::Fast::__wait_for_event",
			"self", "Redis::Fast")
;

	if (items < 2)
	    timeout = -1;
	else {
	    timeout = (double)SvNV(ST(1))
;
	}
#line 1660 "lib/Redis/Fast.xs"
{
    DEBUG_MSG("%s", "start");
    wait_for_event(aTHX_ self, timeout, timeout);
    DEBUG_MSG("%s", "finish");
    XSRETURN(0);
}
#line 2687 "lib/Redis/Fast.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Redis__Fast); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Redis__Fast)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Redis::Fast::_new", XS_Redis__Fast__new);
        newXS_deffile("Redis::Fast::__set_reconnect", XS_Redis__Fast___set_reconnect);
        newXS_deffile("Redis::Fast::__get_reconnect", XS_Redis__Fast___get_reconnect);
        newXS_deffile("Redis::Fast::__set_every", XS_Redis__Fast___set_every);
        newXS_deffile("Redis::Fast::__get_every", XS_Redis__Fast___get_every);
        newXS_deffile("Redis::Fast::__set_debug", XS_Redis__Fast___set_debug);
        newXS_deffile("Redis::Fast::__set_cnx_timeout", XS_Redis__Fast___set_cnx_timeout);
        newXS_deffile("Redis::Fast::__get_cnx_timeout", XS_Redis__Fast___get_cnx_timeout);
        newXS_deffile("Redis::Fast::__set_read_timeout", XS_Redis__Fast___set_read_timeout);
        newXS_deffile("Redis::Fast::__get_read_timeout", XS_Redis__Fast___get_read_timeout);
        newXS_deffile("Redis::Fast::__set_write_timeout", XS_Redis__Fast___set_write_timeout);
        newXS_deffile("Redis::Fast::__get_write_timeout", XS_Redis__Fast___get_write_timeout);
        newXS_deffile("Redis::Fast::__set_current_database", XS_Redis__Fast___set_current_database);
        newXS_deffile("Redis::Fast::__get_current_database", XS_Redis__Fast___get_current_database);
        newXS_deffile("Redis::Fast::__sock", XS_Redis__Fast___sock);
        newXS_deffile("Redis::Fast::__get_port", XS_Redis__Fast___get_port);
        newXS_deffile("Redis::Fast::__set_on_connect", XS_Redis__Fast___set_on_connect);
        newXS_deffile("Redis::Fast::__set_on_build_sock", XS_Redis__Fast___set_on_build_sock);
        newXS_deffile("Redis::Fast::__set_data", XS_Redis__Fast___set_data);
        newXS_deffile("Redis::Fast::__get_data", XS_Redis__Fast___get_data);
        newXS_deffile("Redis::Fast::__set_reconnect_on_error", XS_Redis__Fast___set_reconnect_on_error);
        newXS_deffile("Redis::Fast::__set_next_reconnect_on_error_at", XS_Redis__Fast___set_next_reconnect_on_error_at);
        newXS_deffile("Redis::Fast::__set_ssl", XS_Redis__Fast___set_ssl);
        newXS_deffile("Redis::Fast::__set_ssl_verify_mode", XS_Redis__Fast___set_ssl_verify_mode);
        newXS_deffile("Redis::Fast::is_subscriber", XS_Redis__Fast_is_subscriber);
        newXS_deffile("Redis::Fast::DESTROY", XS_Redis__Fast_DESTROY);
        newXS_deffile("Redis::Fast::__connection_info", XS_Redis__Fast___connection_info);
        newXS_deffile("Redis::Fast::__connection_info_unix", XS_Redis__Fast___connection_info_unix);
        newXS_deffile("Redis::Fast::connect", XS_Redis__Fast_connect);
        newXS_deffile("Redis::Fast::wait_all_responses", XS_Redis__Fast_wait_all_responses);
        newXS_deffile("Redis::Fast::wait_one_response", XS_Redis__Fast_wait_one_response);
        newXS_deffile("Redis::Fast::__std_cmd", XS_Redis__Fast___std_cmd);
        newXS_deffile("Redis::Fast::__quit", XS_Redis__Fast___quit);
        newXS_deffile("Redis::Fast::__shutdown", XS_Redis__Fast___shutdown);
        newXS_deffile("Redis::Fast::__keys", XS_Redis__Fast___keys);
        newXS_deffile("Redis::Fast::__info", XS_Redis__Fast___info);
        newXS_deffile("Redis::Fast::__send_subscription_cmd", XS_Redis__Fast___send_subscription_cmd);
        newXS_deffile("Redis::Fast::wait_for_messages", XS_Redis__Fast_wait_for_messages);
        newXS_deffile("Redis::Fast::__wait_for_event", XS_Redis__Fast___wait_for_event);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

